# Global

##

### Members

#### categoryMap

An array of category objects that map input value ranges to titles and colors. Each category object contains: - `range`: An array with two numbers representing the start and end of the range. - `title`: A string representing the title of the category. - `color`: A string representing the color associated with the category.

Source:
  - alpha/chart-statetrail.js, line 113

#### categoryMap

An array of category objects that map input value ranges to titles and colors. Each category object contains: - `range`: An array with two numbers representing the start and end of the range. - `title`: A string representing the title of the category. - `color`: A string representing the color associated with the category.

Source:
  - alpha/chart-statetrail.js, line 113

#### categoryMap

An array of category objects that map input value ranges to titles and colors. Each category object contains: - `range`: An array with two numbers representing the start and end of the range. - `title`: A string representing the title of the category. - `color`: A string representing the color associated with the category.

Source:
  - alpha/chart-statetrail.js, line 113

#### (constant) color

TODO: color const not really needed, convert to make direct changes to style (see theme changer for code) Use uib-brand.css rather than trying to do local css processing for light/dark Improve slot change handlers and remove on disconnect Allow varient for slots not just the card

Source:
  - alpha/simple-card.js, line 31

#### (constant) color

TODO: color const not really needed, convert to make direct changes to style (see theme changer for code) Use uib-brand.css rather than trying to do local css processing for light/dark Improve slot change handlers and remove on disconnect Allow varient for slots not just the card

Source:
  - alpha/simple-card.js, line 31

#### (constant) color

TODO: color const not really needed, convert to make direct changes to style (see theme changer for code) Use uib-brand.css rather than trying to do local css processing for light/dark Improve slot change handlers and remove on disconnect Allow varient for slots not just the card

Source:
  - alpha/simple-card.js, line 31

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/nav-bar.js, line 33

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/not-complete/container-br.js, line 33

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/not-complete/simple-tree.js, line 33

#### (constant) componentName

Refs: - https://discourse.nodered.org/t/size-of-custom-mdi-switch-icon/91280/9

Source:
  - alpha/simple-switch.js, line 38

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/uib-theme-changer.js, line 42

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/nav-bar.js, line 33

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/not-complete/container-br.js, line 33

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/not-complete/simple-tree.js, line 33

#### (constant) componentName

Refs: - https://discourse.nodered.org/t/size-of-custom-mdi-switch-icon/91280/9

Source:
  - alpha/simple-switch.js, line 38

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/uib-theme-changer.js, line 42

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/nav-bar.js, line 33

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/not-complete/container-br.js, line 33

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/not-complete/simple-tree.js, line 33

#### (constant) componentName

Refs: - https://discourse.nodered.org/t/size-of-custom-mdi-switch-icon/91280/9

Source:
  - alpha/simple-switch.js, line 38

#### (constant) componentName

Copyright (c) 2022-2025 Julian Knight (Totally Information) https://it.knightnet.org.uk, https://github.com/TotallyInformation Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

Source:
  - alpha/uib-theme-changer.js, line 42

#### data

Placeholder for the chart data

Source:
  - alpha/chart-statetrail.js, line 105

#### data

Placeholder for the chart data

Source:
  - alpha/chart-statetrail.js, line 105

#### data

Placeholder for the chart data

Source:
  - alpha/chart-statetrail.js, line 105

#### itemMap

Allows a nice title to be displayed for each item

Source:
  - alpha/chart-statetrail.js, line 119

#### itemMap

Allows a nice title to be displayed for each item

Source:
  - alpha/chart-statetrail.js, line 119

#### itemMap

Allows a nice title to be displayed for each item

Source:
  - alpha/chart-statetrail.js, line 119

#### maxEntries

Max # entries allowed in the display, extra's will be dropped

Source:
  - alpha/state-timeline.js, line 193

#### maxEntries

Max # entries allowed in the display, extra's will be dropped

Source:
  - alpha/state-timeline.js, line 193

#### maxEntries

Max # entries allowed in the display, extra's will be dropped

Source:
  - alpha/state-timeline.js, line 193

#### states

State schema

##### Properties:

Name | Type | Description
--- | --- | ---

`states`

object

Each state ID'd by name

###### Properties

Name | Type | Description
--- | --- | ---
`name` | string | Unique name of the state
`label` | string | Long label for the state
`color` | string | CSS Color specification of timeline state

Source:
  - alpha/state-timeline.js, line 187

#### states

State schema

##### Properties:

Name | Type | Description
--- | --- | ---

`states`

object

Each state ID'd by name

###### Properties

Name | Type | Description
--- | --- | ---
`name` | string | Unique name of the state
`label` | string | Long label for the state
`color` | string | CSS Color specification of timeline state

Source:
  - alpha/state-timeline.js, line 187

#### states

State schema

##### Properties:

Name | Type | Description
--- | --- | ---

`states`

object

Each state ID'd by name

###### Properties

Name | Type | Description
--- | --- | ---
`name` | string | Unique name of the state
`label` | string | Long label for the state
`color` | string | CSS Color specification of timeline state

Source:
  - alpha/state-timeline.js, line 187

#### (constant) styles

TODO: Add optional footer ? topic (uib)

Source:
  - data-list.js, line 29

#### (constant) styles

TODO: Add optional footer ? topic (uib)

Source:
  - data-list.js, line 29

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/chart-statetrail.js, line 32

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/component-template.js, line 28

#### (constant) template

References https://codepen.io/johnred15/pen/NWXagPZ - simple with size/colour options https://webcodespace.com/how-to-create-a-three-state-toggle-switch-using-html-css-and-javascript https://www.w3schools.com/howto/howto_css_switch.asp

Source:
  - alpha/multi-way-switch.js, line 51

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/simple-card.js, line 43

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/simple-container.js, line 25

#### (constant) template

TODO ! Probably need to make the timeline a FIXED timespan (can be a moving fixed span) so widths can be pre-calculated and not change. - std parts - topic, var - should default to the instance id - std schema: msg. payload=slot, .value, .config, .attributes - [x] inherit-style - Optional attrib text is the link to import - else import ./index.css - All should allow default (no value) and string inputs [x] config fn [x] get version - Start/end state times - multi-entries (e.g. send cache) - multi-timelines - data-set attrib - State labels - axis labels - limits: # & time - Add attibs: data-start, data-end - Track previous entry and auto-add data-end if needed - Add chart start/end ts - Add null state when offline - undefined for start and coming back online, null only for offline Refs: https://flows.nodered.org/flow/3827f07ed08826b01bd71b2c874f7fdc https://github.com/hotNipi/node-red-contrib-ui-state-trail/blob/master/ui-state-trail.js#L27

Source:
  - alpha/state-timeline.js, line 56

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/todo-app.js, line 26

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - button-send.js, line 40

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - collapsible-headings.js, line 34

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - html-include.js, line 31

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - labelled-value.js, line 30

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - led-gauge.js, line 28

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - syntax-highlight.js, line 28

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - visible-console.js, line 34

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/chart-statetrail.js, line 32

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/component-template.js, line 28

#### (constant) template

References https://codepen.io/johnred15/pen/NWXagPZ - simple with size/colour options https://webcodespace.com/how-to-create-a-three-state-toggle-switch-using-html-css-and-javascript https://www.w3schools.com/howto/howto_css_switch.asp

Source:
  - alpha/multi-way-switch.js, line 51

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/simple-card.js, line 43

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/simple-container.js, line 25

#### (constant) template

TODO ! Probably need to make the timeline a FIXED timespan (can be a moving fixed span) so widths can be pre-calculated and not change. - std parts - topic, var - should default to the instance id - std schema: msg. payload=slot, .value, .config, .attributes - [x] inherit-style - Optional attrib text is the link to import - else import ./index.css - All should allow default (no value) and string inputs [x] config fn [x] get version - Start/end state times - multi-entries (e.g. send cache) - multi-timelines - data-set attrib - State labels - axis labels - limits: # & time - Add attibs: data-start, data-end - Track previous entry and auto-add data-end if needed - Add chart start/end ts - Add null state when offline - undefined for start and coming back online, null only for offline Refs: https://flows.nodered.org/flow/3827f07ed08826b01bd71b2c874f7fdc https://github.com/hotNipi/node-red-contrib-ui-state-trail/blob/master/ui-state-trail.js#L27

Source:
  - alpha/state-timeline.js, line 56

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/todo-app.js, line 26

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/chart-statetrail.js, line 32

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/component-template.js, line 28

#### (constant) template

References https://codepen.io/johnred15/pen/NWXagPZ - simple with size/colour options https://webcodespace.com/how-to-create-a-three-state-toggle-switch-using-html-css-and-javascript https://www.w3schools.com/howto/howto_css_switch.asp

Source:
  - alpha/multi-way-switch.js, line 51

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/simple-card.js, line 43

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/simple-container.js, line 25

#### (constant) template

TODO ! Probably need to make the timeline a FIXED timespan (can be a moving fixed span) so widths can be pre-calculated and not change. - std parts - topic, var - should default to the instance id - std schema: msg. payload=slot, .value, .config, .attributes - [x] inherit-style - Optional attrib text is the link to import - else import ./index.css - All should allow default (no value) and string inputs [x] config fn [x] get version - Start/end state times - multi-entries (e.g. send cache) - multi-timelines - data-set attrib - State labels - axis labels - limits: # & time - Add attibs: data-start, data-end - Track previous entry and auto-add data-end if needed - Add chart start/end ts - Add null state when offline - undefined for start and coming back online, null only for offline Refs: https://flows.nodered.org/flow/3827f07ed08826b01bd71b2c874f7fdc https://github.com/hotNipi/node-red-contrib-ui-state-trail/blob/master/ui-state-trail.js#L27

Source:
  - alpha/state-timeline.js, line 56

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - alpha/todo-app.js, line 26

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - button-send.js, line 40

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - collapsible-headings.js, line 34

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - html-include.js, line 31

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - labelled-value.js, line 30

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - led-gauge.js, line 28

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - syntax-highlight.js, line 28

#### (constant) template

Only use a template if you want to isolate the code and CSS

Source:
  - visible-console.js, line 34

#### timespan

Max # seconds in the timeline display, old entries will be dropped Set to 0 for unlimited but beware of excessive memory use

Source:
  - alpha/state-timeline.js, line 191

#### timespan

Max # seconds in the timeline display, old entries will be dropped Set to 0 for unlimited but beware of excessive memory use

Source:
  - alpha/state-timeline.js, line 191

#### timespan

Max # seconds in the timeline display, old entries will be dropped Set to 0 for unlimited but beware of excessive memory use

Source:
  - alpha/state-timeline.js, line 191

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/chart-frappe.js, line 238

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/chart-high.js, line 255

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/gauge-steel.js, line 208

#### window[undefined]

Self register the class to global Enables new widgets to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/ghost-thermometer.js, line 610

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/nav-bar.js, line 351

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-apex.js, line 227

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-js.js, line 226

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-plotly.js, line 244

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/container-br.js, line 80

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/simple-tree.js, line 315

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/simple-switch.js, line 272

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/chart-frappe.js, line 238

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/chart-high.js, line 255

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/gauge-steel.js, line 208

#### window[undefined]

Self register the class to global Enables new widgets to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/ghost-thermometer.js, line 610

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/nav-bar.js, line 351

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-apex.js, line 227

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-js.js, line 226

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-plotly.js, line 244

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/container-br.js, line 80

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/simple-tree.js, line 315

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/simple-switch.js, line 272

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/chart-frappe.js, line 238

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/chart-high.js, line 255

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/gauge-steel.js, line 208

#### window[undefined]

Self register the class to global Enables new widgets to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/ghost-thermometer.js, line 610

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/nav-bar.js, line 351

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-apex.js, line 227

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-js.js, line 226

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/chart-plotly.js, line 244

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/container-br.js, line 80

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/not-complete/simple-tree.js, line 315

#### window[undefined]

Self register the class to global Enables new data lists to be dynamically added via JS and lets the static methods be called

Source:
  - alpha/simple-switch.js, line 272

### Methods

#### $(selection) → {HTMLElement|null}

Mini jQuery-like shadow dom selector

##### Parameters:

Name | Type | Description
--- | --- | ---
`selection` |  |

Source:
  - alpha/definition-list.js, line 72

##### Returns:

The first matching element or null if not found

Type
  HTMLElement | null

#### $(selection) → {HTMLElement|null}

Mini jQuery-like shadow dom selector

##### Parameters:

Name | Type | Description
--- | --- | ---
`selection` | string | HTML element selector

Source:
  - alpha/ghost-thermometer.js, line 263

##### Returns:

The discovered element

Type
  HTMLElement | null

#### $(selection) → {HTMLElement|null}

Mini jQuery-like shadow dom selector

##### Parameters:

Name | Type | Description
--- | --- | ---
`selection` |  |

Source:
  - alpha/definition-list.js, line 72

##### Returns:

The first matching element or null if not found

Type
  HTMLElement | null

#### $(selection) → {HTMLElement|null}

Mini jQuery-like shadow dom selector

##### Parameters:

Name | Type | Description
--- | --- | ---
`selection` | string | HTML element selector

Source:
  - alpha/ghost-thermometer.js, line 263

##### Returns:

The discovered element

Type
  HTMLElement | null

#### $(selection) → {HTMLElement|null}

Mini jQuery-like shadow dom selector

##### Parameters:

Name | Type | Description
--- | --- | ---
`selection` |  |

Source:
  - alpha/definition-list.js, line 72

##### Returns:

The first matching element or null if not found

Type
  HTMLElement | null

#### $(selection) → {HTMLElement|null}

Mini jQuery-like shadow dom selector

##### Parameters:

Name | Type | Description
--- | --- | ---
`selection` | string | HTML element selector

Source:
  - alpha/ghost-thermometer.js, line 263

##### Returns:

The discovered element

Type
  HTMLElement | null

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/chart-frappe.js, line 107

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/chart-high.js, line 108

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/gauge-steel.js, line 104

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/ghost-thermometer.js, line 330

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/nav-bar.js, line 247

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-apex.js, line 106

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-js.js, line 102

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-plotly.js, line 110

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/simple-switch.js, line 168

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/chart-frappe.js, line 107

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/chart-high.js, line 108

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/gauge-steel.js, line 104

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/ghost-thermometer.js, line 330

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/nav-bar.js, line 247

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-apex.js, line 106

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-js.js, line 102

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-plotly.js, line 110

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/simple-switch.js, line 168

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/chart-frappe.js, line 107

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/chart-high.js, line 108

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/gauge-steel.js, line 104

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/ghost-thermometer.js, line 330

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/nav-bar.js, line 247

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-apex.js, line 106

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-js.js, line 102

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/not-complete/chart-plotly.js, line 110

#### _uibMsgHandler(evt)

Handle a `uibuilder:msg:_ui:update:${this.id}` custom event

##### Parameters:

Name | Type | Description
--- | --- | ---
`evt` | CustomEvent | uibuilder `uibuilder:msg:_ui:update:${this.id}` custom event evt.details contains the data

Source:
  - alpha/simple-switch.js, line 168

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watch attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/ghost-thermometer.js, line 532

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watched attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | The name of the attribute that has changed
`oldVal` | string | The old value of the attribute
`newVal` | string | The new value of the attribute

Source:
  - alpha/not-complete/uib-wrap.js, line 78

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watched attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/simple-gauge.js, line 159

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watch attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/ghost-thermometer.js, line 532

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watched attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | The name of the attribute that has changed
`oldVal` | string | The old value of the attribute
`newVal` | string | The new value of the attribute

Source:
  - alpha/not-complete/uib-wrap.js, line 78

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watched attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/simple-gauge.js, line 159

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watch attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/ghost-thermometer.js, line 532

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watched attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | The name of the attribute that has changed
`oldVal` | string | The old value of the attribute
`newVal` | string | The new value of the attribute

Source:
  - alpha/not-complete/uib-wrap.js, line 78

#### attributeChangedCallback(attrib, oldVal, newVal)

NOTE: On initial startup, this is called for each watched attrib set in HTML - BEFORE connectedCallback is called

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/simple-gauge.js, line 159

#### checkMode()

When the temp or setpoint changes, check the heating/cooling mode and change if needed

Source:
  - alpha/ghost-thermometer.js, line 299

#### checkMode()

When the temp or setpoint changes, check the heating/cooling mode and change if needed

Source:
  - alpha/ghost-thermometer.js, line 299

#### checkMode()

When the temp or setpoint changes, check the heating/cooling mode and change if needed

Source:
  - alpha/ghost-thermometer.js, line 299

#### doNote(note, lblNote)

Set the note label if required

##### Parameters:

Name | Type | Description
--- | --- | ---
`note` | string | The text to display
`lblNote` | HTMLElement | Reference to the SVG <text> element containing the text

Source:
  - alpha/ghost-thermometer.js, line 279

#### doNote(note, lblNote)

Set the note label if required

##### Parameters:

Name | Type | Description
--- | --- | ---
`note` | string | The text to display
`lblNote` | HTMLElement | Reference to the SVG <text> element containing the text

Source:
  - alpha/ghost-thermometer.js, line 279

#### doNote(note, lblNote)

Set the note label if required

##### Parameters:

Name | Type | Description
--- | --- | ---
`note` | string | The text to display
`lblNote` | HTMLElement | Reference to the SVG <text> element containing the text

Source:
  - alpha/ghost-thermometer.js, line 279

#### floatRound(number, digits) → {number}

Properly round a floating point number (stupid JavaScript!)

##### Parameters:

Name | Type | Default | Description
--- | --- | --- | ---
`number` | number |  | The number to round
`digits` | number | 0 | The required decimal places to round to (default=0)

Source:
  - alpha/ghost-thermometer.js, line 44

##### Returns:

Input number rounded to requested DP's

Type
  number

#### floatRound(number, digits) → {number}

Properly round a floating point number (stupid JavaScript!)

##### Parameters:

Name | Type | Default | Description
--- | --- | --- | ---
`number` | number |  | The number to round
`digits` | number | 0 | The required decimal places to round to (default=0)

Source:
  - alpha/ghost-thermometer.js, line 44

##### Returns:

Input number rounded to requested DP's

Type
  number

#### floatRound(number, digits) → {number}

Properly round a floating point number (stupid JavaScript!)

##### Parameters:

Name | Type | Default | Description
--- | --- | --- | ---
`number` | number |  | The number to round
`digits` | number | 0 | The required decimal places to round to (default=0)

Source:
  - alpha/ghost-thermometer.js, line 44

##### Returns:

Input number rounded to requested DP's

Type
  number

#### getStackTrace() → {Array|null}

Get the file, line and column number of the calling function Used to capture the originating file and line number of the console output for output because the process otherwise changes the file/line number.

Source:
  - visible-console.js, line 105

##### Returns:

An array of arrays containing the file, line and column number or null if parsing fails

Type
  Array | null

#### getStackTrace() → {Array|null}

Get the file, line and column number of the calling function Used to capture the originating file and line number of the console output for output because the process otherwise changes the file/line number.

Source:
  - visible-console.js, line 105

##### Returns:

An array of arrays containing the file, line and column number or null if parsing fails

Type
  Array | null

#### str2bool(strvalue) → {boolean}

Convert a string 'true' or 'false' to a boolean true/false

##### Parameters:

Name | Type | Description
--- | --- | ---
`strvalue` | * | The string representation of the boolean

Source:
  - alpha/ghost-thermometer.js, line 271

##### Returns:

True if strvalue is 'true', false if 'false' or anything else

Type
  boolean

#### str2bool(strvalue) → {boolean}

Convert a string 'true' or 'false' to a boolean true/false

##### Parameters:

Name | Type | Description
--- | --- | ---
`strvalue` | * | The string representation of the boolean

Source:
  - alpha/ghost-thermometer.js, line 271

##### Returns:

True if strvalue is 'true', false if 'false' or anything else

Type
  boolean

#### str2bool(strvalue) → {boolean}

Convert a string 'true' or 'false' to a boolean true/false

##### Parameters:

Name | Type | Description
--- | --- | ---
`strvalue` | * | The string representation of the boolean

Source:
  - alpha/ghost-thermometer.js, line 271

##### Returns:

True if strvalue is 'true', false if 'false' or anything else

Type
  boolean

#### uibSend()

uibuilder send

Source:
  - alpha/ghost-thermometer.js, line 285

#### uibSend()

uibuilder send

Source:
  - alpha/ghost-thermometer.js, line 285

#### uibSend()

uibuilder send

Source:
  - alpha/ghost-thermometer.js, line 285

### Type Definitions

#### CSSLength

A CSS color value (e.g., "red", "#ff0000", "rgb(255, 0, 0)").

##### Type:

- string

Source:
  - alpha/chart-statetrail.js, line 26

#### CSSLength

A CSS color value (e.g., "red", "#ff0000", "rgb(255, 0, 0)").

##### Type:

- string

Source:
  - alpha/chart-statetrail.js, line 26

#### CSSLength

A CSS color value (e.g., "red", "#ff0000", "rgb(255, 0, 0)").

##### Type:

- string

Source:
  - alpha/chart-statetrail.js, line 26